function vexalarm.panel_field()
	return {
		type = "group",
		order= 3,
		args = {
			framesize = {name = "Frame Size", type="header", order=1},
			framewidth = {
				name = "width",
				order=2, type = "range",
				desc = "Sets the width of the frame",
				step = 1, min = 0, max = 2000,
				set = function(info,val) vexalarm_frame_bg:SetWidth(val) vexalarm_frame_width=val end,
				get = function() return vexalarm_frame_width end
				},
			frameheight = {
				name = "height",
				order=3, type = "range",
				desc = "Sets the height of the frame",
				step = 1, min = 0, max = 2000,
				set = function(info,val) vexalarm_frame_bg:SetHeight(val) vexalarm_frame_height=val end,
				get = function() return vexalarm_frame_height end
				},
			frameposition = {name = "Frame Position", type="header", order=5},
			frame_pos_x = {
				name = "X-Ordinate",
				order=6, type = "range",
				desc = "Sets the x position of the frame",
				step = 1, min = 0, max = 2000,
				set = function(info,val) vexalarm_frame_xvalue=val vexalarm_frame_bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", vexalarm_frame_xvalue, vexalarm_frame_yvalue) end,
				get = function() return vexalarm_frame_xvalue end
				},
			frame_pos_y = {
				name = "Y-Ordinate",
				order=7, type = "range",
				desc = "Sets the y position of the frame",
				step = 1, min = -2000, max = 0,
				set = function(info,val) vexalarm_frame_yvalue=val vexalarm_frame_bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", vexalarm_frame_xvalue, vexalarm_frame_yvalue) end,
				get = function() return vexalarm_frame_yvalue end
				},
			frame_posspace = {name ="\n\n", type = "description", order=8},
				

				
			framebackground = {name = "Background & Border", type="header", order=20},
			framebackdrop = {
				name = "Background",
				order=21, type = "select",
				dialogControl = "LSM30_Background",
				desc = "Sets the frame's background",
				values = vexalarm.LSM:HashTable("background"),
				set = function(self,key) vexalarm_texture_bg=key vexalarm_change_frame_bg() end,
				get = function() return vexalarm_texture_bg end,
				},
			framebgcolor = {
				name = "Background Color",
				order=22, type = "color",
				desc = "Sets the frame's background color (background texture has to be 'solid')",
				hasAlpha = true,
				set = function(info,r,g,b,a) vexalarm_backdrop_color[1]=r vexalarm_backdrop_color[2]=g vexalarm_backdrop_color[3]=b vexalarm_backdrop_color[4]=a vexalarm_change_frame_bg() end,
				get = function() return vexalarm_backdrop_color[1], vexalarm_backdrop_color[2], vexalarm_backdrop_color[3], vexalarm_backdrop_color[4] end,
				},
			frameedge = {
				name = "Border",
				order=23, type = "select",
				dialogControl = "LSM30_Border",
				desc = "Sets the frame's border",
				values = vexalarm.LSM:HashTable("border"),
				set = function(self,key) vexalarm_edge_texture=key vexalarm_change_frame_bg() end,
				get = function() return vexalarm_edge_texture end,
				},
			insets_left = {
				name = "Insets Range Left",
				order=24, type = "range",
				desc = "Space between the border and the background on the left side",
				step = 1, min = 0, max = 100,
				set = function(info,val) vexalarm_texture_insets[1]=val vexalarm_change_frame_bg() end,
				get = function() return vexalarm_texture_insets[1] end,
				},
			insets_right = {
				name = "Insets Range Right",
				order=25, type = "range",
				desc = "Space between the border and the background on the right side",
				step = 1, min = 0, max = 100,
				set = function(info,val) vexalarm_texture_insets[2]=val vexalarm_change_frame_bg() end,
				get = function() return vexalarm_texture_insets[2] end,
				},
			insets_top = {
				name = "Insets Range Top",
				order=26, type = "range",
				desc = "Space between the border and the background on the top",
				step = 1, min = 0, max = 100,
				set = function(info,val) vexalarm_texture_insets[3]=val vexalarm_change_frame_bg() end,
				get = function() return vexalarm_texture_insets[3] end,
				},
			insets_bottom = {
				name = "Insets Range Bottom",
				order=27, type = "range",
				desc = "Space between the border and the background on the bottom",
				step = 1, min = 0, max = 100,
				set = function(info,val) vexalarm_texture_insets[4]=val vexalarm_change_frame_bg() end,
				get = function() return vexalarm_texture_insets[4] end,
				}
			}
		}
end