--Colorize proclaim
function vexalarm_colorize_class(msg, caster, class)
	local returnvalue =""
	if class == nil or class =="" then
		if caster then	class = select(2, UnitClass(caster))
		else			class = select(2, UnitClass(msg)) end
	end
	if class == "DEATHKNIGHT" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[1]..msg.."|r"
	elseif class == "DRUID" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[2]..msg.."|r"
	elseif class == "HUNTER" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[3]..msg.."|r"
	elseif class == "MAGE" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[4]..msg.."|r"
	elseif class == "PALADIN" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[5]..msg.."|r"
	elseif class == "PRIEST" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[6]..msg.."|r"
	elseif class == "ROGUE" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[7]..msg.."|r"
	elseif class == "SHAMAN" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[8]..msg.."|r"
	elseif class == "WARLOCK" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[9]..msg.."|r"
	elseif class == "WARRIOR" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[10]..msg.."|r"
	elseif class == "MONK" then returnvalue="|CFF"..vexalarm_proclaim_classcolor[11]..msg.."|r"
	else returnvalue=msg
	end

	return returnvalue
end

function vexalarm_colorize_status(statustext, status)
	local returnvalue = ""
	if status then returnvalue="|CFF"..vexalarm_proclaim_text_status_color[1][1]..""..statustext.."|r"
	else	 returnvalue="|CFF"..vexalarm_proclaim_text_status_color[2][1]..statustext.."|r" end
	return returnvalue
end

function vexalarm_colorize_specific(msg, sub)
	return "|CFF"..vexalarm_proclaim_constant_colors[sub][1]..msg.."|r"
end


--Proclaim functions
function vexalarm_spellcheck(auraID, player, eventchar)
	local returnvalue = ""
	playerrole = vexalarm_getplayerrole(player)
	auratocheck=""..auraID

	--overflow check - check data
	local currenttime = time()
	if auratocheck==vexalarm_last_spell_id and vexalarm_last_spell_timestamp+1>=currenttime then
		if eventchar == "SPELL_CAST_SUCCESS" and vexalarm_last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_CAST_SUCCESS" and vexalarm_last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_APPLIED" and vexalarm_last_spell_event == "SPELL_CAST_SUCCESS" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_APPLIED" and vexalarm_last_spell_event == "SPELL_AURA_APPLIED" then returnvalue = "dejavue"
		elseif eventchar == "SPELL_AURA_REMOVED" and vexalarm_last_spell_event == "SPELL_AURA_REMOVED" then returnvalue = "dejavue"
		end
	end
	
	if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" then
		--check in selfbuffs
		if returnvalue == "" then
			for i=1,#vexalarm_selfbuffs do
				if(auratocheck == vexalarm_selfbuffs[i][1] and vexalarm_selfbuffs[i][playerrole+1]) then	returnvalue="selfbuff" end
			end
		end
	
		--check in buffs
		if returnvalue == "" then
			for i=1,#vexalarm_buffs do 
				if(auratocheck == vexalarm_buffs[i][1] and vexalarm_buffs[i][playerrole+1]) then returnvalue="buff" end
			end
		end
	
		--check in grpbuffs
		if returnvalue == "" then
			for i=1,#vexalarm_grpbuffs do 
				if(auratocheck == vexalarm_grpbuffs[i][1] and vexalarm_grpbuffs[i][playerrole+1]) then returnvalue="grpbuff" end
			end
		end
	
	elseif eventchar == "SPELL_CAST_SUCCESS" then
		--check in instants
		if returnvalue == "" then
			for i=1,#vexalarm_instants do 
				if(auratocheck == vexalarm_instants[i][1] and vexalarm_instants[i][playerrole+1]) then returnvalue="instant" end
			end
		end
	
		--check in instantsself
		if returnvalue == "" then
			for i=1,#vexalarm_instantsself do 
				if(auratocheck == vexalarm_instantsself[i][1] and vexalarm_instantsself[i][playerrole+1]) then returnvalue="instantself" end
			end
		end
	end
	--overflow check - update data
	if returnvalue ~= "" and returnvalue ~= "dejavue" then
		vexalarm_last_spell_id = auratocheck
		vexalarm_last_spell_timestamp = currenttime
		vexalarm_last_spell_event = eventchar
	end
	return returnvalue
end

local vexalarm_printouts = {false, false}

function vexalarm_check_fulltext()
	local framedata
	local currenttime = time()
	local rank = {0}
	if #vexalarm_proclaim_timestamps~= 0 then
		for i=1, #vexalarm_proclaim_texts do
			if vexalarm_proclaim_timestamps[i] ~= nil then
				framedata = vexalarm_proclaim_texts[i]
				
				if vexalarm_proclaim_timestamps[i]+vexalarm_times[2]+vexalarm_times[1]+0.5 <= currenttime then
					framedata[1]:Hide()
					table.remove(vexalarm_proclaim_timestamps, i)
					table.remove(vexalarm_proclaim_texts, i)
					if not(vexalarm_frame_allow_scrolling) then
						local place=framedata[4]
						vexalarm_printouts[place]=false
					end
				elseif vexalarm_proclaim_timestamps[i]+vexalarm_times[1] < currenttime and vexalarm_proclaim_timestamps[i]+vexalarm_times[1]+vexalarm_times[2]+0.5 > currenttime and vexalarm_proclaim_vanish and not(framedata[3]) then
					if vexalarm_frame_allow_scrolling then
						framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , vexalarm_frame_proclaim_xvalue, (-vexalarm_frame_proclaim_spacing*(#rank+1))+vexalarm_frame_proclaim_yvalue)
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#vexalarm_printouts+1 do
								if place == 1 and not(vexalarm_printouts[i]) then place = i end
							end
							vexalarm_printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , vexalarm_frame_proclaim_xvalue, (-vexalarm_frame_proclaim_spacing*place)+vexalarm_frame_proclaim_yvalue)
						end
					end
					framedata[3] = true
					rank[#rank+1] = i
				else
					if vexalarm_frame_allow_scrolling then
						framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , vexalarm_frame_proclaim_xvalue, (-vexalarm_frame_proclaim_spacing*(#rank+1))+vexalarm_frame_proclaim_yvalue)
					else
						if framedata[4]==nil then
							local place = 1
							for i=1,#vexalarm_printouts+1 do
								if place == 1 and not(vexalarm_printouts[i]) then place = i end
							end
							vexalarm_printouts[place] = true
							framedata[4] = place
							framedata[2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , vexalarm_frame_proclaim_xvalue, (-vexalarm_frame_proclaim_spacing*place)+vexalarm_frame_proclaim_yvalue)
						end
					end
					framedata[1]:Show()
					rank[#rank+1] = i
				end
			end
		end
	end
	
	if vexalarm_frame_allow_scrolling then
		if #rank>vexalarm_max_events+1 then
			for i=1, #rank-vexalarm_max_events-1 do
				framedata = vexalarm_proclaim_texts[rank[i+1]]
				framedata[1]:Hide()
				table.remove(vexalarm_proclaim_timestamps, rank[i+1])
				table.remove(vexalarm_proclaim_texts, rank[i+1])
			end
			vexalarm_check_fulltext()
		end
	end
	
	if vexalarm_lock then
		vexalarm_frame_bg:SetMovable(false)
		vexalarm_frame_bg:EnableMouse(false)
	end
end

function vexalarm_generate_fulltext(msg, status)
	local currenttime = time()
	local insert = {}
	local newmsgframe = CreateFrame("Frame", "vexalarm_proclaim_textframe", vexalarm_frame_bg)
		newmsgframe.name = "vexalarm_proclaim_textframe"
		newmsgframe.parent = "vexalarm_frame_bg"
	local newmsg = newmsgframe:CreateFontString("newmsgframe", "ARTWORK", "GameFontNormal")
		newmsg:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT" , 20, -3000)
		if status then 	newmsg:SetTextColor(vexalarm_text_color[1][1], vexalarm_text_color[1][2], vexalarm_text_color[1][3], vexalarm_text_color[1][4])
		else 			newmsg:SetTextColor(vexalarm_text_color[2][1], vexalarm_text_color[2][2], vexalarm_text_color[2][3], vexalarm_text_color[2][4]) end
		newmsg:SetFont(vexalarm.LSM:Fetch("font", vexalarm_frame_font), vexalarm_frame_fontsize)	
		newmsg:SetJustifyH(vexalarm_frame_font_align)
		newmsg:SetWidth(vexalarm_frame_width-vexalarm_frame_proclaim_xvalue)
		newmsg:SetText(msg)	
		newmsgframe:Hide()
		newmsgframe_anigrp = newmsgframe:CreateAnimationGroup("newmsgframe_anigrp")
		newmsgframe_anigrp:SetLooping("NONE")
		newmsgframe_ani = newmsgframe_anigrp:CreateAnimation("Alpha")
		newmsgframe_ani:SetStartDelay(vexalarm_times[1])
		newmsgframe_ani:SetEndDelay(5) -- Within the 5s the frame will hopefully be hidden and deleted, if not the scripthandler will delete it by calling vexalarm_check_fulltext()
		newmsgframe_anigrp:SetScript("OnFinished", function () vexalarm_check_fulltext() end)
		newmsgframe_ani:SetOrder(1)
		newmsgframe_ani:SetSmoothing("IN")
		if vexalarm_proclaim_vanish then
			newmsgframe_ani:SetDuration(vexalarm_times[2])
			newmsgframe_ani:SetChange(-1)
		else
			newmsgframe_ani:SetDuration(0)
			newmsgframe_ani:SetChange(1)
		end
		newmsgframe_anigrp:Play()
	
	insert[1] = newmsgframe
	insert[2] = newmsg
	insert[3] = false
	insert[5] = newmsgframe_anigrp
		
	table.insert(vexalarm_proclaim_timestamps, #vexalarm_proclaim_timestamps+1, currenttime)
	table.insert(vexalarm_proclaim_texts, #vexalarm_proclaim_texts+1, insert)
end

function vexalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	local customalarm = ""
	--load custom alarm text
	if alarmtype == "buff" 			and status 		then customalarm = vexalarm_proclaim_buff[1]
	elseif alarmtype == "buff" 		and not(status) then customalarm = vexalarm_proclaim_buff[2]
	elseif alarmtype == "selfbuff"	and status  	then customalarm = vexalarm_proclaim_selfbuff[1]
	elseif alarmtype == "selfbuff"	and not(status) then customalarm = vexalarm_proclaim_selfbuff[2]
	elseif alarmtype == "grpbuff"	and status 		then customalarm = vexalarm_proclaim_grpbuff[1]
	elseif alarmtype == "grpbuff"	and not(status) then customalarm = vexalarm_proclaim_grpbuff[2]
	elseif alarmtype == "instant" 					then customalarm = vexalarm_proclaim_instant
	elseif alarmtype == "instantself" 				then customalarm = vexalarm_proclaim_instantself
	end
	
	--load custom status msg
	if status then statustext=vexalarm_proclaim_text_status[1]
	else statustext=vexalarm_proclaim_text_status[2] end
	-- change [spell]
	if spell ~= nil then
		customalarm = string.gsub(customalarm, "{spell}", spell)
		customalarm = string.gsub(customalarm, "{spell_sc}", vexalarm_colorize_specific(spell, 3))
		customalarm = string.gsub(customalarm, "{spell_cc}", vexalarm_colorize_class(spell, caster))
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "{caster}", caster)
		customalarm = string.gsub(customalarm, "{caster_sc}", vexalarm_colorize_specific(caster, 1))
		customalarm = string.gsub(customalarm, "{caster_cc}", vexalarm_colorize_class(caster))
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "{target}", target)
		customalarm = string.gsub(customalarm, "{target_sc}", vexalarm_colorize_specific(target, 2))
		customalarm = string.gsub(customalarm, "{target_cc}", vexalarm_colorize_class(target))
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "{status}", statustext)
		customalarm = string.gsub(customalarm, "{status_sc}", vexalarm_colorize_status(statustext, status))
		customalarm = string.gsub(customalarm, "{status_cc}", vexalarm_colorize_status(statustext, status))
	end
	return customalarm
end

function vexalarm_getplayerrole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player);
		
		if role == "DAMAGER" then returnvalue = 3
		elseif role == "HEALER" then returnvalue = 2
		elseif role == "TANK" then returnvalue = 1
		else returnvalue = 4
		end
	end
	return returnvalue
end

function vexalarm_proclaim(alarmtype, spell, caster, target, status)
	msg = vexalarm_generate_singlealarm(alarmtype, spell, caster, target, status)
	if msg~="" then vexalarm_generate_fulltext(msg, status) end
	vexalarm_check_fulltext()
	if vexalarm_allow_sounds and msg~="" and vexalarm_frame_bg:IsShown() then
		if status then 	PlaySoundFile(vexalarm_sounds2play[1][1], vexalarm_sounds2play[1][2])
		else 			PlaySoundFile(vexalarm_sounds2play[2][1], vexalarm_sounds2play[2][2])
		end
	end
	
end
