--Slash Command
SLASH_VEXALARMm1 = "/vexalarm"
SLASH_VEXALARM2 = "/vexa"


--UI Functions
function SlashCmdList.VEXALARM(msg, editbox)
	if msg == "reset" then
		vexalarm_frame_bg:SetPoint("TOPLEFT", 600, -300)
		print("|CFFFF7D0AVex Alarm|r - frame has been reset")
	elseif msg == "option" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "options" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "config" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "configs" then	InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel);
	elseif msg == "print" then vexalarm_print_variables()
	elseif msg == "print spells" then vexalarm_print_variables_spells()
	elseif msg == "defaults" then
		print("|CFFFF7D0AVex Alarm|r - defaults loaded")
		vexalarm_load_variables(true)
	elseif msg == "enable" then
		if vexalarm_show then 	vexalarm_show=false vexalarm_checkshow(false) print("|CFFFF7D0AVex Alarm|r - Addon disabled")
		else 					vexalarm_show=true  vexalarm_checkshow(true) 	print("|CFFFF7D0AVex Alarm|r - Addon enabled") end
	else
		print ("|CFFFF7D0Avexalarm|r cmd list - /vexalarm and /cda can be used")
		print ("|CFFFF7D0A/vexalarm|r reset - resets the frameposition")
		print ("|CFFFF7D0A/vexalarm|r option/options/config/configs - opens the option frame")
		print ("|CFFFF7D0A/vexalarm|r defaults - resets the addon to defaults")
		print ("|CFFFF7D0A/vexalarm|r enable - enables/disables the addon")
	end
end

function vexalarm_checkshow()
	if vexalarm_show then
		if vexalarm_showonlyinfight and vexalarm_infight then vexalarm_frame_bg:Show()
		elseif vexalarm_showonlyinfight and not(vexalarm_infight) then vexalarm_frame_bg:Hide()
		else vexalarm_frame_bg:Show() end
	else vexalarm_frame_bg:Hide() end
end

function vexalarm_setsound()
	vexalarm_sounds2play[1][1] = vexalarm.LSM:Fetch("sound", vexalarm_sounds[1][1])
	vexalarm_sounds2play[1][2] = vexalarm_sounds[1][2]
	vexalarm_sounds2play[2][1] = vexalarm.LSM:Fetch("sound", vexalarm_sounds[2][1])
	vexalarm_sounds2play[2][2] = vexalarm_sounds[2][2]
end

function vexalarm_change_frame_bg()
	vexalarm_frame_bg:SetBackdrop({bgFile=vexalarm.LSM:Fetch("background", vexalarm_texture_bg),
												edgeFile=vexalarm.LSM:Fetch("border", vexalarm_edge_texture),
												tile=vexalarm_tile,
												tilesize=vexalarm_tile_size,
												edgesize=vexalarm_edge_size,
												insets={left=vexalarm_texture_insets[1],
													right=vexalarm_texture_insets[2],
													top=vexalarm_texture_insets[3],
													bottom=vexalarm_texture_insets[4]}})
	vexalarm_frame_bg:SetBackdropColor(vexalarm_backdrop_color[1],vexalarm_backdrop_color[2],vexalarm_backdrop_color[3],vexalarm_backdrop_color[4])
	 								
end

function vexalarm_textframe_template(text, fontsize, parent, color, xvalue, yvalue, align)
	local returnvalue
	if fontsize == ""	then	fontsize = "GameFontNormal" end
	returnvalue = parent:CreateFontString(nil, "ARTWORK", fontsize)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT" , xvalue, yvalue)
	returnvalue:SetTextColor(color[1], color[2], color[3], color[4])
	returnvalue:SetText(text)	
	returnvalue:SetJustifyH(align)
	return returnvalue
end

function vexalarm_button_template(text, name, template, parent, xvalue, yvalue, width, height)
	local returnvalue
	if template == ""	then	template = "UIPanelButtonTemplate" end
	returnvalue = CreateFrame("Button", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	returnvalue:SetText(text)
	return returnvalue
end

function vexalarm_editbox_template(text, name, template, parent, xvalue, yvalue, width, height, multiline)
	local returnvalue
	if template == ""	then	template = "InputBoxTemplate" end
	returnvalue = CreateFrame("EditBox", name, parent, template)
	returnvalue:SetHeight(height)
	returnvalue:SetWidth(width)
	returnvalue:SetText(text)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	returnvalue:SetMaxLetters(255)
	returnvalue:SetMultiLine(multiline)
	returnvalue:SetCursorPosition(0)
	returnvalue:SetAutoFocus(false)
	returnvalue:SetTextInsets(0, 0, 0, 0)
	return returnvalue
end

function vexalarm_checkbox_template(name, tooltip, template, parent, xvalue, yvalue, width, height)
	local returnvalue
	if template == ""	then	template = "ChatConfigCheckButtonTemplate" end
	returnvalue = CreateFrame("CheckButton", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetHitRectInsets(0, 0, 0, 0);
	returnvalue.tooltip = tooltip
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	return returnvalue
end

function vexalarm_slider_template(name, template, parent, xvalue, yvalue, width, height, minvalue, maxvalue, value, text)
	local returnvalue
	if template == ""	then	template = "OptionsSliderTemplate" end
	returnvalue = CreateFrame("Slider", name, parent, template)
	returnvalue:SetWidth(width)
	returnvalue:SetHeight(height)
	returnvalue:SetPoint("TOPLEFT", parent, "TOPLEFT", xvalue, yvalue)
	getglobal(returnvalue:GetName() .. "Low"):SetText(minvalue)
	getglobal(returnvalue:GetName() .. "High"):SetText(maxvalue)
	getglobal(returnvalue:GetName() .. "Text"):SetText(text)
	returnvalue:SetMinMaxValues(minvalue, maxvalue)
	returnvalue:SetValue(value)
	returnvalue:Show()
	return returnvalue
end